#include <OSA.h>


#if   defined(__OSAPICC18__)
    #include <pic18.h>
#elif defined (__OSAPICC16__)
    #include <pic.h>
#elif defined (__OSAPICC12__)
    #include <pic.h>
#endif


//------------------------------------------------------------------------------
#ifdef __OSAMCC18__
#pragma udata access ACCESS
#endif



NEAR OST_SYSTEM_FLAGS   OS_Flags    __osa30_near;
NEAR _OST_INT_TYPE      _OS_temp    __osa30_near;
#ifndef __OSAPICC12__
NEAR _OST_INT_TYPE      _OS_tempH   __osa30_near;
#endif

OST_TASK_POINTER NEAR _OS_CurTask   __osa30_near;    //  

#if !defined(OS_DISABLE_PRIORITY)
    OST_TASK_POINTER OS_BANK _OS_BestTask __osa30_near;   //     (   OS_Sched() )
    OST_TASK_POINTER OS_BANK _OS_LastTask __osa30_near;   //   
    OS_BANK _OST_INT_TYPE _OS_best_priority __osa30_near;
#endif

//------------------------------------------------------------------------------

#ifdef OS_ENABLE_TIMER

    #if OS_TIMERS24 > 0
    OS_BANK _OST_INT_TYPE  OS_Ticks    __osa30_near;
    #endif

    #ifdef OS_ENABLE_PTIMERS
        OS_BANK OST_PTIMER_CB  _OS_PTimers __osa30_near;       //    
        #if defined(__OSAMCC30__)
            OS_BANK OST_PTIMER * _OS_PTimerWork __osa30_near; //    
        #endif
    #endif
#endif

#ifdef __OSAMCC18__
#pragma udata
#endif
//------------------------------------------------------------------------------


            

//------------------------------------------------------------------------------
#if OS_BSEMS > 0
            #if OS_BANK_BSEM == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_bsems
                #endif
            #endif
OS_BSEM_BANK _OST_INT_TYPE OS_BSems[(OS_BSEMS + _OST_INT_SIZE-1) / _OST_INT_SIZE] __osa30_near;
            #if OS_BANK_BSEM == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------




//------------------------------------------------------------------------------
//    
            #if OS_BANK_TASKS == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_tasks
                #endif
            #endif
OS_TASKS_BANK OST_TCB OS_TaskVars[OS_TASKS] __osa30_near;
            #if OS_BANK_TASKS == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
//------------------------------------------------------------------------------




//------------------------------------------------------------------------------
//    
#if OS_TIMERS > 0
            #if OS_BANK_TIMEOUTS == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timeout
                #endif
            #endif
OS_TIMEOUTS_BANK _OST_INT_TYPE OS_Timeouts[(OS_TIMERS + _OST_INT_SIZE - 1) / _OST_INT_SIZE] __osa30_near;
            #if OS_BANK_TIMEOUTS == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------




//------------------------------------------------------------------------------
#if OS_TIMERS32 > 0
            #if OS_BANK_TIMERS32 == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timers32
                #endif
            #endif
OS_TIMERS32_BANK __osa_uint32 OS_Timers32[OS_TIMERS32] __osa30_near;   //   
            #if OS_BANK_TIMERS32 == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------
#if OS_TIMERS24 > 0
            #if OS_BANK_TIMERS24 == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timers24
                #endif
            #endif
OS_TIMERS24_BANK __osa_uint16 OS_Timers24[OS_TIMERS24] __osa30_near;   //   
            #if OS_BANK_TIMERS24 == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------
#if OS_TIMERS16 > 0
            #if OS_BANK_TIMERS16 == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timers16
                #endif
            #endif
OS_TIMERS16_BANK __osa_uint16 OS_Timers16[OS_TIMERS16] __osa30_near;   //   
            #if OS_BANK_TIMERS16 == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------
#if OS_TIMERS8 > 0
            #if OS_BANK_TIMERS8 == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timers8
                #endif
            #endif
OS_TIMERS8_BANK __osa_uint8 OS_Timers8[OS_TIMERS8] __osa30_near;   //   
            #if OS_BANK_TIMERS8 == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------












//------------------------------------------------------------------------------

#if defined(__OSAPICC18__)
    #include <port\osa_picc18.c>         // HT-PICC18
#elif defined(__OSAMCC18__)
    #include <port\osa_mcc18.c>          // MPLAB C18
#elif defined(__OSAMCC30__)
    #include <port\osa_mcc30.c>          // MPLAB C30
#elif defined(__OSAPICC12__)
    #include <port\osa_picc12.c>         // HT_PICC for 12-bit PICs
#elif defined(__OSAPICC__)
    #include <port\osa_picc16.c>         // HT_PICC
#elif defined(__OSACCS18__)
    #include <port\osa_ccs18.c>          // CCS-PICC (for PIC18 only)
    //      , .. PICC   
    // #locate,     #ifdef'
    #include "port\osa_ccs18_locate.h"
#else
    #error "Unknown compiler!"
#endif

//------------------------------------------------------------------------------





















/**************************************************************************************************
 * 
 * C O U N T I N G    S E M A P H O R E S
 *
 * (OS_ENABLE_CSEM must be defined in OSAcfg.h)
 *
 **************************************************************************************************/


#ifdef OS_ENABLE_CSEM

#if OS_CSEM_SIZE > 1
/************************************************************************/
/*                                              */
/************************************************************************/

    bit _OS_CheckCSem(OST_CSEM *pCSem)
    {
        _OST_INT_TYPE cGIETemp;
        cGIETemp = OS_DI();
        if (*pCSem) cGIETemp |= 1;
        OS_RI(cGIETemp);
        if (cGIETemp & 1) return 1;
        return 0;
    }

/************************************************************************/
/*  ()                                  */
/************************************************************************/
    void _OS_ClearCSem(OST_CSEM *pCSem)
    {
        _OST_INT_TYPE cGIETemp;
        cGIETemp = OS_DI();
        *pCSem = 0;
        OS_RI(cGIETemp);
    }

#endif


/************************************************************************/
/*     1                                    */
/************************************************************************/
#if !defined(_OS_SignalCSem_DEFINED)
void _OS_SignalCSem (OST_CSEM *pCSem)
{
    #ifdef OS_ENABLE_INT_SERVICE
        _OST_INT_TYPE cGIETemp;
        cGIETemp = OS_DI();
    #endif

    OS_Flags.bEventError = 0;               //   ,    

    (*pCSem)++;
    if (!*pCSem) {
        (*pCSem) = -1;
        OS_Flags.bEventError = 1;
    }
    
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
}
#endif  // !defined(_OS_SignalCSem)

#endif  // OS_CSEM_ENABLE














    
    
/****************************************************************************************************
 * 
 *        
 * 
 *
 ****************************************************************************************************/
//------------------------------------------------------------------------------
#ifdef OS_ENABLE_CRITICAL_SECTION
//------------------------------------------------------------------------------
    
/************************************************************************/
/*                                                */
/************************************************************************/
#if !defined(OS_EnterCriticalSection_DEFINED)
void OS_EnterCriticalSection (void)
{
    _OST_INT_TYPE temp;
    temp = OS_DI();
    OS_Flags.bInCriticalSection = 1; 

    #ifdef __OSAMCC30__
        OS_Flags.cIPL_Temp = 0;
        *((_OST_INT_TYPE *)&OS_Flags) |= temp;
    #elif defined(__OSAPICC12__)
    #else
        OS_Flags.bGIE_CTemp = 0;
        if (temp & 0x80) OS_Flags.bGIE_CTemp = 1;

        #if defined(__OSA18__)
            OS_Flags.bGIEL_CTemp = 0;
            if (temp & 0x40) OS_Flags.bGIEL_CTemp = 1;
        #endif
    #endif
}
#endif

/************************************************************************/
/*                                              */
/************************************************************************/
#if !defined(OS_LeaveCriticalSection_DEFINED)
void OS_LeaveCriticalSection (void)
{
    char temp;
    OS_Flags.bInCriticalSection = 0; 
    #ifdef __OSAMCC30__
        temp = *((unsigned int *)&OS_Flags) & 0x00E0;
    #elif defined(__OSAPICC12__)
    #else
        temp = 0;
        if (OS_Flags.bGIE_CTemp) temp |= 0x80;
        #if defined(__OSA18__)
            if (OS_Flags.bGIEL_CTemp) temp |= 0x40;
        #endif
    #endif
    OS_RI(temp);
}
#endif

//------------------------------------------------------------------------------
#endif      //     #ifdef OS_ENABLE_CRITICAL_SECTION
//------------------------------------------------------------------------------


















//------------------------------------------------------------------------------
#ifdef OS_ENABLE_TIMER

/****************************************************************************************************
 * 
 *                                  
 *
 ****************************************************************************************************/
/************************************************************************/
/*                                                                      */
/*                                    */
/* (  )                                         */
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#if !defined(_OS_InitDelay_DEFINED)
//------------------------------------------------------------------------------
void _OS_InitDelay (OST_TIMER Delay)
{

    _OS_SET_FSR_CUR_TASK();
    _OS_bTaskCanContinue = 0;
    _OS_bTaskDelay = 0;

    if (Delay)
    {

        Delay ^= -1;
        Delay ++;
        _OS_CurTask->Timer = Delay;
        _OS_SET_FSR_CUR_TASK();
        _OS_bTaskDelay = 1;
        _OS_bTaskReady = 1;

    }
}
//------------------------------------------------------------------------------
#endif  // !defined(_OS_InitDelay_DEFINED)
//------------------------------------------------------------------------------

//______________________________________________________________________________
//******************************************************************************

#endif  // #ifdef OS_TIMER



    










    
    
    
    
    

    








/****************************************************************************************************
 * 
 * 
 *                                   
 *  
 *
 ****************************************************************************************************/

void OS_Init (void)
{
    *((NEAR _OST_INT_TYPE*)&OS_Flags) = 0;
    OS_Init_ProcSpec(); //      

    #if (OS_BSEMS > 11*8) || (OS_TIMERS > 11*8) || ((OS_BSEMS > 0 || OS_TIMERS > 0) && defined(__OSAMCC30__))
        _OST_INT_TYPE n;
    #endif
    
    #if !defined(OS_DISABLE_PRIORITY)
        _OS_LastTask = (OS_TASKS_BANK OST_TASK_POINTER) &OS_TaskVars[OS_TASKS - 1];
    #endif
    
    //------------------------------------------------------------------------------
    //   
    #if OS_TIMERS > 11*8 || ((OS_TIMERS > 0) && defined(__OSAMCC30__))
        n = sizeof(OS_Timeouts);
        do {
            OS_Timeouts[n-1] = 0;
        } while (--n);
    #else
        #if OS_TIMERS > 0
            OS_Timeouts[0] = 0;
        #endif

        #if OS_TIMERS > 1*8
            OS_Timeouts[1] = 0;
        #endif

        #if OS_TIMERS > 2*8
            OS_Timeouts[2] = 0;
        #endif

        #if OS_TIMERS > 3*8
            OS_Timeouts[3] = 0;
        #endif

        #if OS_TIMERS > 4*8
            OS_Timeouts[4] = 0;
        #endif

        #if OS_TIMERS > 5*8
            OS_Timeouts[5] = 0;
        #endif

        #if OS_TIMERS > 6*8
            OS_Timeouts[6] = 0;
        #endif

        #if OS_TIMERS > 7*8
            OS_Timeouts[7] = 0;
        #endif

        #if OS_TIMERS > 8*8
            OS_Timeouts[8] = 0;
        #endif

        #if OS_TIMERS > 9*8
            OS_Timeouts[9] = 0;
        #endif

        #if OS_TIMERS > 10*8
            OS_Timeouts[10] = 0;
        #endif

    #endif
    
    #if defined(OS_ENABLE_TIMER) && defined(OS_ENABLE_PTIMERS)
        *((OS_BANK char*)&_OS_PTimers.Flags) = 0;
        _OS_PTimers.Flags.bActive = 1;    //    OS_CreatePTimer
    #endif

    //------------------------------------------------------------------------------
    //   
    #if OS_BSEMS > 11*8 || ((OS_BSEMS > 0) && defined(__OSAMCC30__))
        n = sizeof(OS_BSems) / sizeof(_OST_INT_TYPE);
        do {
            OS_BSems[n-1] = 0;
        } while (--n);
    #else
        #if OS_BSEMS > 0
            OS_BSems[0] = 0;
        #endif

        #if OS_BSEMS > 1*8
            OS_BSems[1] = 0;
        #endif

        #if OS_BSEMS > 2*8
            OS_BSems[2] = 0;
        #endif

        #if OS_BSEMS > 3*8
            OS_BSems[3] = 0;
        #endif

        #if OS_BSEMS > 4*8
            OS_BSems[4] = 0;
        #endif

        #if OS_BSEMS > 5*8
            OS_BSems[5] = 0;
        #endif

        #if OS_BSEMS > 6*8
            OS_BSems[6] = 0;
        #endif

        #if OS_BSEMS > 7*8
            OS_BSems[7] = 0;
        #endif

        #if OS_BSEMS > 8*8
            OS_BSems[8] = 0;
        #endif

        #if OS_BSEMS > 9*8
            OS_BSems[9] = 0;
        #endif

        #if OS_BSEMS > 10*8
            OS_BSems[10] = 0;
        #endif
    #endif

   
    //------------------------------------------------------------------------------
    #if OS_TASKS > 0
        _OS_CurTask = (OST_TASK_POINTER) OS_TaskVars;
        _OS_temp = OS_TASKS;
        do {
            _OS_StopTask();
            _OS_CurTask ++;
        } while (--_OS_temp);
    #endif
}   













    
    
    
    
    
/****************************************************************************************************
 * 
 * 
 *                                      
 *  
 *
 ****************************************************************************************************/
    



/************************************************************************/
/*                                                                      */
/*     .                              */
/*  :                                                           */
/*      FSR -                                      */
/*      CARRY - =1 - ,                                                */
/*              =0 -    (  OS_TASKS)    */
/*                                                                      */
/************************************************************************/

//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------

#if !defined(_OS_CreateTask_DEFINED)
bit _OS_CreateTask(_OST_INT_TYPE priority, OST_CODE_POINTER TaskAddr)
{
    OST_TASK_POINTER Task;
    
    OS_Flags.bError = 0;

    #if defined(OS_DISABLE_PRIORITY)
    priority = 0;   //    
    #endif

    Task = (OST_TASK_POINTER)OS_TaskVars;
    _OS_temp = OS_TASKS;
    do {
        if (!Task->State.bEnable)
        {
            ((OST_TASK_STATE*)&priority)->bEnable = 1;
            ((OST_TASK_STATE*)&priority)->bReady = 1;
            

            Task->pTaskPointer = TaskAddr;
            #ifdef OS_ENABLE_TIMER
                Task->Timer = 0;
            #endif
            #ifdef __OSA18__
                Task->cTempFSR1 = 0;
            #endif
            *((OS_TASKS_BANK char*)&Task->State) = priority;
            //    FSR =    
            _fsr = (_FSR_TYPE)Task;
            OS_Flags.bError = 0;
            return 1;
        
        }
        Task ++;
    } while (_OS_temp--);
    //  ,     
    OS_Flags.bError = 1;
    return 0;
}
#endif  // !defined(_OS_CreateTask_DEFINED)


























/****************************************************************************************************
 * 
 * 
 *                              
 *  
 *       
 *
 ****************************************************************************************************/


#ifdef OS_ENABLE_TIMER
#ifndef OS_USE_INLINE_TIMER
void OS_Timer (void)
{                            
    __OS_TimerInline(0);
}
#endif
#endif











 /******************************************************************************************
 *
 *             P T I M E R '    
 *
 ******************************************************************************************/
#ifdef OS_ENABLE_PTIMERS

/************************************************************************/
/*                                                                      */
/************************************************************************/
#if !defined(_OS_CreatePTimer_DEFINED)
void _OS_CreatePTimer (OST_PTIMER *ptimer)
{
    _OS_temp = OS_DI();
    
    ptimer->Next = _OS_PTimers.Next;
    ptimer->Flags = _OS_PTimers.Flags;
    ptimer->Timer = 0;

    _OS_PTimers.Next = (OST_PTIMER*)ptimer;
    _OS_PTimers.Flags.bNextEnable = 1;
    
    #if !defined(__OSAPICC12__)
    OS_RI(_OS_temp);
    #endif
}
#endif  // !defined(_OS_CreatePTimer_DEFINED)





/************************************************************************/
/*                                                                      */
/************************************************************************/
#if !defined(_OS_DeletePTimer_DEFINED)
void _OS_DeletePTimer (OST_PTIMER *ptimer)
{

    OST_PTIMER *ptcb;
    
    ptcb = (OST_PTIMER*)&_OS_PTimers;
    while (ptcb->Flags.bNextEnable) {
        if (ptcb->Next == ptimer) {   //  
            ptcb->Next = ptimer->Next;
            if (!ptimer->Flags.bNextEnable) ptcb->Flags.bNextEnable = 0;
            ptimer->Flags.bActive = 0;
            return;
        }
        ptcb = ptcb->Next;
    }
}
#endif  // !defined(_OS_DeletePTimer_DEFINED)
        



#endif  //  OS_ENABLE_PTIMERS


























/****************************************************************************************************
 * 
 *                                /               
 *                  
 *
 * (  )
 *
 ****************************************************************************************************/


//------------------------------------------------------------------------------
#if !defined(_OS_CheckEvent_DEFINED)
//------------------------------------------------------------------------------
#if     defined(__OSA16__)  || defined(__OSA12__)
    bit _OS_CheckEvent (char bEvent)
    #define _OS_CheckEvent_EXIT_GOOD    return 1
    #define _OS_CheckEvent_EXIT_BAD     return 0
#else 
    void _OS_CheckEvent (_OST_INT_TYPE bEvent)
    #define _OS_CheckEvent_EXIT_GOOD    return
    #define _OS_CheckEvent_EXIT_BAD     _PIC18_POP()
#endif
    {

        OS_Flags.bTimeout = 0;
        _fsr = (_FSR_TYPE)&_OS_CurTask->State;
        _SET_TASK_IRP();
        if (bEvent) {
            if (_OS_bTaskReady) {
                #ifdef OS_ENABLE_TIMER
                    _OS_bTaskDelay = 0;
                #endif
                _OS_CheckEvent_EXIT_GOOD;
            }
            _OS_bTaskReady = 1;
        } else {
            _OS_bTaskReady = 0;
        }
        #ifdef OS_ENABLE_TIMER
            if (_OS_bTaskTimeout && _OS_bTaskCanContinue) {
                OS_Flags.bTimeout = 1;
                _OS_CheckEvent_EXIT_GOOD;
            }
        #endif
        _OS_CheckEvent_EXIT_BAD;
    
    }

//------------------------------------------------------------------------------
#endif  // !defined(_OS_CheckEvent_DEFINED)
//------------------------------------------------------------------------------
    
    

        

        






/****************************************************************************************************
 * 
 * 
 *                                                    
 *  
 *
 ****************************************************************************************************/


//------------------------------------------------------------------------------

#if defined(OS_ENABLE_QSMSG) && !defined(OS_MSG_SMSG_IDENTICAL)


/************************************************************************/
/*                                                                      */
/*                           */
/*  1,                        */
/*                                                                      */
/************************************************************************/

//------------------------------------------------------------------------------
#if !defined(_OS_SendQSMsg_DEFINED)
//------------------------------------------------------------------------------
void _OS_SendQSMsg (OST_QSMSG *pQSMsg, OST_SMSG SMsg)
{
    OST_QUEUE_CONTROL   q;
    _OST_INT_TYPE temp;

    #ifdef OS_ENABLE_INT_SERVICE
        _OST_INT_TYPE cGIETemp;
        cGIETemp = OS_DI();
    #endif
    
    q = pQSMsg->Q;
    OS_Flags.bEventError = 0;
    
    if (q.cSize == q.cFilled)                               //   ,    .
    {                                                       //   OS_SendQSMsg    
        pQSMsg->pSMsg[q.cBegin] = SMsg;                     // ,        .
        q.cBegin++;                                         //       OS_SendQSMsgNoWait,
        if (q.cBegin == q.cSize) q.cBegin = 0;              //       ,  
                                                            //   .
        OS_Flags.bEventError = 1;
        goto EXIT;
    }
    temp = q.cBegin + q.cFilled;
    if (temp >= q.cSize) temp -= q.cSize;
    pQSMsg->pSMsg[temp] = SMsg;
    q.cFilled++;
EXIT:
    pQSMsg->Q = q;
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
}
//------------------------------------------------------------------------------
#endif  // !defined(_OS_SendQSMsg_DEFINED)
//------------------------------------------------------------------------------


/************************************************************************/
/*                                                                      */
/*                                 */
/*                                                                      */
/************************************************************************/

//------------------------------------------------------------------------------
#if !defined(_OS_GetQSMsg_DEFINED)
//------------------------------------------------------------------------------
OST_SMSG _OS_GetQSMsg (OST_QSMSG *pQSMsg)
{
    OST_QUEUE_CONTROL   q;
    _OST_INT_TYPE temp;
    #ifdef OS_ENABLE_INT_SERVICE
        _OST_INT_TYPE cGIETemp;
        cGIETemp = OS_DI();
    #endif

    q = pQSMsg->Q;
    temp = q.cBegin;
    q.cBegin++;
    if (q.cBegin >= q.cSize) q.cBegin = 0;
    q.cFilled--;
    pQSMsg->Q = q;
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
    return pQSMsg->pSMsg[temp];
}
//------------------------------------------------------------------------------
#endif  // !defined(_OS_GetQSMsg_DEFINED)
//------------------------------------------------------------------------------
#endif




//------------------------------------------------------------------------------
#if defined(OS_ENABLE_QMSG)

/************************************************************************/
/*                                                                      */
/*                                   */
/*  1,                        */
/*                                                                      */
/************************************************************************/


//------------------------------------------------------------------------------
#if !defined(_OS_SendQMsg_DEFINED)
//------------------------------------------------------------------------------
void _OS_SendQMsg (OST_QMSG *pQMsg, OST_MSG Msg)
{

    OST_QUEUE_CONTROL   q;
    _OST_INT_TYPE temp;

    #ifdef OS_ENABLE_INT_SERVICE
        _OST_INT_TYPE cGIETemp;
        cGIETemp = OS_DI();
    #endif
    q = pQMsg->Q;
    OS_Flags.bEventError = 0;

    if (q.cSize == q.cFilled)                               //   ,    .
    {                                                       //   OS_SendQSMsg    
        pQMsg->pMsg[q.cBegin] = Msg;                        // ,        .
        q.cBegin++;                                         //       OS_SendQSMsgNoWait,
        if (q.cBegin == q.cSize) q.cBegin = 0;              //       ,  
                                                            //   .
        OS_Flags.bEventError = 1;
        goto EXIT;
    }
    temp = q.cBegin + q.cFilled;
    if (temp >= q.cSize) temp -= q.cSize;
    pQMsg->pMsg[temp] = Msg;
    q.cFilled++;
EXIT:
    pQMsg->Q = q;
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
}
//------------------------------------------------------------------------------
#endif  // !defined(_OS_SendQMsg_DEFINED)
//------------------------------------------------------------------------------



/************************************************************************/
/*                                                                      */
/*                                         */
/*                                                                      */
/************************************************************************/

//------------------------------------------------------------------------------
#if !defined(_OS_GetQMsg_DEFINED)
//------------------------------------------------------------------------------
OST_MSG _OS_GetQMsg (OST_QMSG *pQMsg)
{
    OST_QUEUE_CONTROL   q;
    _OST_INT_TYPE temp;
    #ifdef OS_ENABLE_INT_SERVICE
        _OST_INT_TYPE cGIETemp;
        cGIETemp = OS_DI();
    #endif

    q = pQMsg->Q;
    temp = q.cBegin;
    q.cBegin++;
    if (q.cBegin >= q.cSize) q.cBegin = 0;
    q.cFilled--;
    pQMsg->Q = q;
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
    return pQMsg->pMsg[temp];
}
//------------------------------------------------------------------------------
#endif  // !defined(_OS_GetQMsg_DEFINED)
//------------------------------------------------------------------------------
#endif
//------------------------------------------------------------------------------




