
#define OS_Init_ProcSpec()      //  MCC18 -  

/**************************************************************************************************
 * 
 *                                       M C C 1 8 
 *
 *
 **************************************************************************************************/


void _OS_ClrReadySetClrCanContinue (void);

/************************************************************************/
/*                          */
/************************************************************************/

void OS_SchedRetPoint (void)
{
    _OS_SET_FSR_CUR_TASK_W(OS_CODE_POINTER_SIZE + 1);
    _postdec = _fsr1l - _OS_tempH;

    _OS_SavePC();
    _OS_bTaskReady = 1;
    
    _PIC18_POP();
}

/************************************************************************/
/*                        */
/************************************************************************/
void OS_SchedRetPointNoSave (void)
{
    _PIC18_POP();
}

/************************************************************************/
/*                                                                      */
/************************************************************************/


void OS_ClearReady (void)
{
    _OS_temp = 0;
    _asm    goto    _OS_ClrReadySetClrCanContinue   _endasm
}

/************************************************************************/
/*                                                                      */
/************************************************************************/
void OS_ClearReadySetCanContinue (void)
{
    _OS_temp = 0xFF;
    _asm    goto    _OS_ClrReadySetClrCanContinue   _endasm
}


//------------------------------------------------------------------------------
//      
//    GOTO :
//      OS_ClearReady()
//      OS_ClearReadySetCanContinue()
// ,   -  ,  
//------------------------------------------------------------------------------
void _OS_ClrReadySetClrCanContinue (void)
{


    OS_Flags.bEventError = 0;
    //_fsr = (_FSR_TYPE)&_OS_CurTask->cTempFSR1;
    
    _OS_SET_FSR_CUR_TASK_W(OS_CODE_POINTER_SIZE + 1);
    _postdec = _fsr1l - _OS_tempH;
    _OS_SavePC();
    _OS_bTaskReady = 0;

    #if defined(OS_ENABLE_TIMER)
        _OS_bTaskCanContinue = 0;
        if (_OS_temp & 0x01) _OS_bTaskCanContinue = 1;
    #endif

}
















/**************************************************************************************************
 * 
 *            F S R       O S _ C U R _ T A S K
 *
 *   
 *
 **************************************************************************************************/

void _OS_SET_FSR_CUR_TASK (void)
{
    _asm    
        movlw   0
        goto __OS_SET_FSR_CUR_TASK_W
    _endasm
}



void __OS_SET_FSR_CUR_TASK_W (void)
{
    _asm
        addwf   _OS_CurTask + 0, 0, 0
        movwf   _fsr + 0, 0
        #if OS_BANK_TASKS == 0 
            clrf    _fsr + 1, 0
        #else
            movlw   0
            addwfc  _OS_CurTask + 1, 0, 0
            movwf   _fsr + 1, 0
        #endif
    _endasm
}





















/**************************************************************************************************
 * 
 * C O U N T I N G    S E M A P H O R E S
 *
 * (OS_ENABLE_CSEM must be defined in OSAcfg.h)
 *
 **************************************************************************************************/












/****************************************************************************************************
 * 
 *       GIEH:GIEL
 * 
 * char OS_DI (void)   
 *
 ****************************************************************************************************/
/****************************************************************************************************
 * 
 *       OS_DI 
 * 
 * void OS_RI (char)   
 *
 ****************************************************************************************************/
//------------------------------------------------------------------------------
#define OS_DI_DEFINED
//------------------------------------------------------------------------------
char OS_DI (void)
{
    _asm
        movf    _intcon, 0, 0
        andlw   0xC0
    _DIH_REPEAT:
        bcf     _intcon, 7, 0
        btfsc   _intcon, 7, 0
        bra     _DIH_REPEAT
        btfss   _rcon, 7, 0
        bra     _DI_EXIT
    _DIL_REPEAT:
        bcf     _intcon, 6, 0
        btfsc   _intcon, 6, 0
        bra     _DIL_REPEAT
    _DI_EXIT:
    _endasm
}


void _OS_RI ()
{
    _asm
        btfsc   _wreg, 7, 0
        bsf     _intcon, 7, 0
        btfsc   _rcon, 7, 0
        btfss   _wreg, 6, 0
        bra     _RI_EXIT
        bsf     _intcon, 6, 0
    _RI_EXIT:
    _endasm

}








 
    
    
/****************************************************************************************************
 * 
 *        
 * 
 *
 ****************************************************************************************************/
//------------------------------------------------------------------------------
#ifdef OS_ENABLE_CRITICAL_SECTION
//------------------------------------------------------------------------------
    
/************************************************************************/
/*                                                */
/************************************************************************/
//------------------------------------------------------------------------------
#define OS_EnterCriticalSection_DEFINED
//------------------------------------------------------------------------------
void OS_EnterCriticalSection (void)
{
    _OST_INT_TYPE temp;
    temp = OS_DI();
    OS_Flags.bInCriticalSection = 1; 

    OS_Flags.bGIE_CTemp = 0;
    if (temp & 0x80) OS_Flags.bGIE_CTemp = 1;

    OS_Flags.bGIEL_CTemp = 0;
    if (temp & 0x40) OS_Flags.bGIEL_CTemp = 1;
}

/************************************************************************/
/*                                              */
/************************************************************************/
//------------------------------------------------------------------------------
#define OS_LeaveCriticalSection_DEFINED
//------------------------------------------------------------------------------
void OS_LeaveCriticalSection (void)
{
    char temp;
    OS_Flags.bInCriticalSection = 0; 
    temp = 0;
    if (OS_Flags.bGIE_CTemp) temp |= 0x80;
    if (OS_Flags.bGIEL_CTemp) temp |= 0x40;
    OS_RI(temp);
}

//------------------------------------------------------------------------------
#endif      //     #ifdef OS_ENABLE_CRITICAL_SECTION
//------------------------------------------------------------------------------


















//------------------------------------------------------------------------------
#ifdef OS_ENABLE_TIMER

/****************************************************************************************************
 * 
 *                                  
 *
 ****************************************************************************************************/
/************************************************************************/
/*                                                                      */
/*                                    */
/* (  )                                         */
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_InitDelay_DEFINED
//------------------------------------------------------------------------------
void _OS_InitDelay (OST_TIMER Delay)
{

    char temp;
    temp = 0;               //    MCC18:     Delay
    if (Delay) temp = 1;    //   FSR0 (.  (temp & 1))
    
    _OS_SET_FSR_CUR_TASK();
    _OS_bTaskCanContinue = 0;
    _OS_bTaskDelay = 0;

    if (temp & 1)           
    {

        Delay ^= -1;
        Delay ++;
        
        _OS_CurTask->Timer = Delay;
        _OS_SET_FSR_CUR_TASK();
        _OS_bTaskDelay = 1;
        _OS_bTaskReady = 1;

    }
}

//______________________________________________________________________________
//******************************************************************************

#endif  // #ifdef OS_TIMER



    










    
    
    
    
    

    




















    
    
    
    
    
/****************************************************************************************************
 * 
 * 
 *                                      
 *  
 *
 ****************************************************************************************************/
    
/************************************************************************/
/*                                                                      */
/*                     */
/*                                   */
/*                                                                      */
/************************************************************************/

//------------------------------------------------------------------------------
#define _OS_StopTask_DEFINED
//------------------------------------------------------------------------------

void _OS_StopTask (void)
{
    _OS_SET_FSR_CUR_TASK();
    _indf = 0;
}




/************************************************************************/
/*                                                                      */
/*     .                              */
/*  :                                                           */
/*      FSR -                                      */
/*      CARRY - =1 - ,                                                */
/*              =0 -    (  OS_TASKS)    */
/*                                                                      */
/************************************************************************/

//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
#define _OS_CreateTask_DEFINED
//------------------------------------------------------------------------------
bit _OS_CreateTask(_OST_INT_TYPE priority, OST_CODE_POINTER TaskAddr)
{
    OST_TASK_POINTER Task;
    
    OS_Flags.bError = 0;

    #if defined(OS_DISABLE_PRIORITY)
    priority = 0;   //    
    #endif

    Task = (OST_TASK_POINTER)OS_TaskVars;
    _OS_temp = OS_TASKS;
    do {
        if (!Task->State.bEnable)
        {
            ((OST_TASK_STATE*)&priority)->bEnable = 1;
            ((OST_TASK_STATE*)&priority)->bReady = 1;
            

            Task->pTaskPointer = TaskAddr;
            #ifdef OS_ENABLE_TIMER
                Task->Timer = 0;
            #endif
            Task->cTempFSR1 = 0;
            *((OS_TASKS_BANK char*)&Task->State) = priority;
            _fsr = (_FSR_TYPE)Task;
            //    FSR =    
            OS_Flags.bError = 0;
            return 1;
        
        }
        Task ++;
    } while (_OS_temp--);
    //  ,     
    OS_Flags.bError = 1;
    return 0;
}




































 /******************************************************************************************
 *
 *             P T I M E R '    
 *
 ******************************************************************************************/
#ifdef OS_ENABLE_PTIMERS

/************************************************************************/
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_CreatePTimer_DEFINED
//------------------------------------------------------------------------------
void _OS_CreatePTimer (OST_PTIMER *ptimer)
{
    _OS_temp = OS_DI();
    _fsr = (_FSR_TYPE) ptimer;
    _postinc = *((OS_BANK char*)&_OS_PTimers.Flags);   //  bActive,
                                                    //  bTimeout,
                                                    //  bRun
                                                    //  bNextEnable
    _postinc = *((OS_BANK char*)&_OS_PTimers.Next + 0);
    _postinc = *((OS_BANK char*)&_OS_PTimers.Next + 1);
    _postinc = 0;
    #if  OS_TIMER_SIZE >= 2
    _postinc = 0;
    #endif
    #if  OS_TIMER_SIZE == 4
    _postinc = 0;
    _postinc = 0;
    #endif

    _OS_PTimers.Next = (OST_PTIMER*)ptimer;
    _OS_PTimers.Flags.bNextEnable = 1;
    
    #if !defined(__OSAPICC12__)
    OS_RI(_OS_temp);
    #endif
}





/************************************************************************/
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_DeletePTimer_DEFINED
//------------------------------------------------------------------------------
void _OS_DeletePTimer (OST_PTIMER *ptimer)
{

    OST_PTIMER *ptcb;
    char flags;
    _fsr = (_FSR_TYPE)ptimer;
    _OS_ClearIndfTimerActive;           //   
    flags = _postinc;
    *((char*)&ptcb + 0) = _postinc;
    *((char*)&ptcb + 1) = _postinc;
    _fsr = (_FSR_TYPE)&_OS_PTimers;
REPEAT:
    if (_OS_CheckPostincTimerNextEnable)
    {
        if (_indf == *((char*)&ptimer + 0))
        {
            if (_preinc == *((char*)&ptimer + 1)){
                _OS_temp = OS_DI();
                _postdec = *((char*)&ptcb + 1);
                _postdec = *((char*)&ptcb + 0);
                
                
                if (!(flags & 0x8)) _OS_ClearIndfTimerNextEnable;   //  bNextEnable
                //    , , !((OST_PTIMER_FLAGS*)&flags)->bNextEnable
                //   FSR0,       ptimer 


                return;
            }
            _fsr--;
        } 
        _asm
            movf    _postinc, 0, 0
            movff   _indf, _fsr + 1
            movwf   _fsr + 0, 0
        _endasm
        goto REPEAT;
    }
        
}



#endif  //  OS_ENABLE_PTIMERS


























/****************************************************************************************************
 * 
 *                                /               
 *                  
 *
 * (  )
 *
 ****************************************************************************************************/

//------------------------------------------------------------------------------
#define _OS_CheckEvent_DEFINED
//------------------------------------------------------------------------------

#define bEvent  _OS_temp
void _OS_CheckEvent (void)
{
    OS_Flags.bTimeout = 0;
    _OS_SET_FSR_CUR_TASK();
    if (bEvent) {
        if (_OS_bTaskReady) {
            #ifdef OS_ENABLE_TIMER
                _OS_bTaskDelay = 0;
            #endif
            return;
        }
        _OS_bTaskReady = 1;
    } else {
        _OS_bTaskReady = 0;
    }
    #ifdef OS_ENABLE_TIMER
        if (_OS_bTaskTimeout && _OS_bTaskCanContinue) {
            OS_Flags.bTimeout = 1;
            return;
        }
    #endif
    _PIC18_POP();
}


    

        

        

