NEAR OST_TASK_STATE     OS_state    __osa30_near;


/**************************************************************************************************
 * 
 *                                       M C C 3 0
 *
 *
 **************************************************************************************************/

/************************************************************************/
/*                          */
/************************************************************************/

void _OS_SchedRetPoint (void)
{
    asm volatile("  bset    _OS_state, #3       "); // bReady

    asm volatile("  btss    _OS_Flags, #10      "); //  bOSSchedRetPoint_LNK
    asm volatile("  bra     OS_RETURN_SKIP_ULNK ");
    asm volatile("  ulnk                        ");
    asm volatile("OS_RETURN_SKIP_ULNK:          ");
    
    //------------------------------------------------------------------------------
    asm volatile("  mov     __OS_CurTask, w0    ");
    asm volatile("  pop.d   w2                  "); //   
    asm volatile("  mov     w2, [w0 + #2]       ");
    asm volatile("  goto    OS_RETURN_SAVE_STACK");
}

/************************************************************************/
/*                        */
/************************************************************************/
void _OS_SchedRetPointNoSave (void)
{
    asm volatile("  mov     #(1<<11), w0        "); //  bOSSchedRetPointNoSave_LNK
    asm volatile("OS_RETURN:                    ");
    asm volatile("  and     _OS_Flags, wreg     "); 
    asm volatile("  bra     z, OS_RETURN_NS_SKIP_ULNK");
    asm volatile("  ulnk                        ");
    asm volatile("OS_RETURN_NS_SKIP_ULNK:       ");

    //------------------------------------------------------------------------------
    asm volatile("  mov     __OS_CurTask, w0    ");
    asm volatile("  pop.d   w2                  "); //    

    //------------------------------------------------------------------------------
    asm volatile("OS_RETURN_SAVE_STACK:         ");

    /*   (C30 manual 4.12 Function call conversions)   */

    asm volatile("  add     #4, w0              ");
    asm volatile("  mov.d   w8,  [w0++]         ");
    asm volatile("  mov.d   w10, [w0++]         ");
    asm volatile("  mov.d   w12, [w0++]         ");
    asm volatile("  mov.w   w14, [w0++]         ");

    asm volatile("  mov     w15, w4             "); //    
    asm volatile("  mov     [w0], w15           "); //     

    asm volatile("  btsc    _OS_Flags, #9       "); // bTaskReplaced
    asm volatile("  clr     w4                  "); // ,    
    asm volatile("  mov     w4, [w0]            "); //    
    asm volatile("  bclr    _OS_Flags, #9       "); // bTaskReplaced
    asm volatile("  return                      ");
}

/************************************************************************/
/*                                                                      */
/************************************************************************/


//------------------------------------------------------------------------------
void _OS_CLEAR_READY (void)
{
    #ifdef OS_ENABLE_TIMER
        asm volatile("  bclr    _OS_state, #5   "); // bCanContinue
    #endif

    asm volatile("  mov     #(1<<12), w0        "); //  bOSClearReady_LNK
    asm volatile("OS_CLEAR_READY:               ");
    asm volatile("  and     _OS_Flags, wreg     "); 
    asm volatile("  bra     z, OS_CLEAR_READY_SKIP_ULNK");
    asm volatile("  ulnk                        ");
    asm volatile("OS_CLEAR_READY_SKIP_ULNK:");

    asm volatile("  bclr    _OS_Flags, #0       "); // bEventError
    asm volatile("  bclr    _OS_state, #3       "); // bReady
    
    asm volatile("  mov     __OS_CurTask, w0    ");
    asm volatile("  mov     [w15 - #4], w2      "); //   
    asm volatile("  mov     w2, [w0 + #2]       ");
    asm volatile("  return                      ");
}
//------------------------------------------------------------------------------
void _OS_CLEAR_READY_SET_CANCONTINUE (void)
{
    #ifdef OS_ENABLE_TIMER
        asm volatile("  bset    _OS_state, #5   "); // bCanContinue
    #endif
    asm volatile("  mov     #(1<<13), w0        "); // bOSClearReadySetCanConinue_LNK
    asm volatile("  goto    OS_CLEAR_READY      ");
}
//------------------------------------------------------------------------------












/****************************************************************************************************
 * 
 *   bOSxxx_LNK  ,      
 *     
 * 
 *
 ****************************************************************************************************/

/************************************************************************/
/*   lnk                          */
/* (    small, ..  large   */
/*   .handle)                                                  */
/************************************************************************/
void OS_CheckLnk (OST_CODE_POINTER sub)
{
    asm volatile("  clr     TBLPAG                  ");
    asm volatile("  tblrdh  [w0], w0                ");
    asm volatile("  xor     #0xFA, w0               ");
    asm volatile("  bra     nz, 0f                  ");
    asm volatile("  mov     w3, w0                  ");
    asm volatile("  ior     _OS_Flags               ");
    asm volatile("0:                                ");
    asm volatile("  rlnc    w3, w3                  ");

    
/**    
    asm volatile("  bclr    _OS_Flags, #9           "); // bOS_LNK
    asm volatile("  clr     TBLPAG                  ");
    asm volatile("  tblrdh  [w0], w0                ");
    asm volatile("  xor     #0xFA, w0               ");
    asm volatile("  bra     nz, OS_CHECK_LINK_SKIP  ");
    asm volatile("  mov     w3, w0                  ");
    asm volatile("  ior     _OS_Flags               ");
    asm volatile("OS_CHECK_LINK_SKIP:               ");
    asm volatile("  rlnc    w3, w3                  ");/**/
}

/************************************************************************/
/*                                                                      */
/************************************************************************/

void OS_Init_ProcSpec (void)
{
    asm volatile("  mov     #(1<<10), w3    ");
    OS_CheckLnk((OST_CODE_POINTER)_OS_SchedRetPoint);
    OS_CheckLnk((OST_CODE_POINTER)_OS_SchedRetPointNoSave);
    OS_CheckLnk((OST_CODE_POINTER)_OS_CLEAR_READY);
    OS_CheckLnk((OST_CODE_POINTER)_OS_CLEAR_READY_SET_CANCONTINUE);
    OS_CheckLnk((OST_CODE_POINTER)_OS_CheckEvent);

}












/****************************************************************************************************
 * 
 *       GIEH:GIEL
 * 
 * char OS_DI (void)   
 *
 ****************************************************************************************************/
/****************************************************************************************************
 * 
 *       OS_DI 
 * 
 * void OS_RI (char)   
 *
 ****************************************************************************************************/

//------------------------------------------------------------------------------
#define OS_DI_DEFINED
//------------------------------------------------------------------------------


_OST_INT_TYPE OS_DI (void)
{
    _OST_INT_TYPE temp;
    temp = SR;
    SR |= 0x00E0;
    return temp & 0x00E0;
}

/*   ,    warning,   return'
{
    asm volatile("   mov     _SR, w1         ");
    asm volatile("   mov     #0x00E0, w0     ");
    asm volatile("   ior     _SR             ");
    asm volatile("   and     w0, w1, w0      ");
}
*/


void OS_RI (_OST_INT_TYPE temp)
{
    asm volatile("   mov     #0xFF1F, w1     ");
    asm volatile("   and     w0, w1, w1      ");
    asm volatile("   mov     #0x00E0, w0     ");
    asm volatile("   ior     SR, WREG       ");
    asm volatile("   and     w0, w1, w0      ");
    asm volatile("   mov     w0, SR         ");
}







//------------------------------------------------------------------------------
#ifdef OS_ENABLE_TIMER

/****************************************************************************************************
 * 
 *                                  
 *
 ****************************************************************************************************/
/************************************************************************/
/*                                                                      */
/*                                    */
/* (  )                                         */
/*                                                                      */
/************************************************************************/

//------------------------------------------------------------------------------
#define _OS_InitDelay_DEFINED
//------------------------------------------------------------------------------
void _OS_InitDelay (OST_TIMER Delay)
{

    _OS_bTaskCanContinue = 0;
    _OS_bTaskDelay = 0;

    _OS_CurTask->State = OS_state;  //   bDelay,    
    if (Delay)
    {

        Delay = -Delay;
        _OS_CurTask->Timer = Delay;
        _OS_SET_FSR_CUR_TASK();
        _OS_bTaskDelay = 1;
        _OS_bTaskReady = 1;

    }
    _OS_CurTask->State = OS_state;  //   Ready  Delay
}

//______________________________________________________________________________
//******************************************************************************

#endif  // #ifdef OS_TIMER











/****************************************************************************************************
 * 
 * 
 *                                      
 *  
 *
 ****************************************************************************************************/
    
/************************************************************************/
/*                                                                      */
/*                     */
/*                                   */
/*                                                                      */
/************************************************************************/
 
//------------------------------------------------------------------------------
#define _OS_StopTask_DEFINED
//------------------------------------------------------------------------------
void _OS_StopTask (void)
{
    *((OS_TASKS_BANK _OST_INT_TYPE*)&_OS_CurTask->State) = 0;
}





/************************************************************************/
/*                                                                      */
/*     .                              */
/*  :                                                           */
/*      =1 - ,                                                        */
/*      =0 -    (  OS_TASKS)            */
/*                                                                      */
/************************************************************************/

//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
#define _OS_CreateTask_DEFINED
//------------------------------------------------------------------------------

void _OS_CreateTask(_OST_INT_TYPE priority, OST_CODE_POINTER TaskAddr)
{
    //------------------------------------------------------------------------------
    // according to manual "4.12.1 Function parameters":
    // w0 - priority 
    // w1 - TaskAddr
    //------------------------------------------------------------------------------
    // my vars:
    // w0 - state of new task
    // w2 - state of current task
    // w7 - pointer to task descriptor
    // w6 - loop counter
    // w3, w4 - work reg
    

    asm volatile("  bclr    _OS_Flags, #1       ");     // bError

    asm volatile("  mov     #%0, w7 "::"i"(OS_TaskVars));       // w7 -> OS_TaskVars
    asm volatile("  mov     #%0, w6 "::"i"(OS_TASKS));          // w6 - counter
    
    asm volatile("0:                            ");     // CREATE_TASK_REPEAT
    asm volatile("  mov     [w7], w2            ");
    asm volatile("  btsc    w2, #6              ");     // bEnable
    asm volatile("  bra     1f                  ");     // CREATE_TASK_NEXT
    
    //  , - ,   
    asm volatile(";CREATE_TASK_FOUND:           ");
    asm volatile("  bset    w0, #6              ");     // bEanble
    asm volatile("  bset    w0, #3              ");     // bReady
    asm volatile("  mov     w0, [w7]            ");     // Write state

    // save task address
    asm volatile("  mov     w1, [w7 + #2]       ");     // Write TaskAddr
    asm volatile("  clr     w4                  ");
    asm volatile("  mov     w4, [w7 + #18]      ");     // Write stack pointer (first time = 0)

    asm volatile("  bra     2f                  ");     // CREATE_TASK_RETURN
    
    asm volatile("1:                            ");     // CREATE_TASK_NEXT
    asm volatile("  add     #%0, w7 "::"i"(sizeof(OST_TCB)));
    asm volatile("  dec     w6, w6  ");
    asm volatile("  bra     nz, 0b              ");     // CREATE_TASK_REPEAT


    asm volatile(";CREATE_TASK_BAD:             ");
    asm volatile("  bset    _OS_Flags, #1       ");     // bError
    asm volatile("2:                            ");     // CREATE_TASK_RETURN

}














/******************************************************************************************
 *
 *             P T I M E R '    
 *
 ******************************************************************************************/
#ifdef OS_ENABLE_PTIMERS

/************************************************************************/
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_CreatePTimer_DEFINED
//------------------------------------------------------------------------------
void _OS_CreatePTimer (OST_PTIMER *ptimer)
{
    _OS_temp = OS_DI();
    
    ptimer->Next = _OS_PTimers.Next;
    ptimer->Flags = _OS_PTimers.Flags;
    ptimer->Timer = 0;


    _OS_PTimers.Next = (OST_PTIMER*)ptimer;
    _OS_PTimers.Flags.bNextEnable = 1;
    
    OS_RI(_OS_temp);
}





/************************************************************************/
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_DeletePTimer_DEFINED
//------------------------------------------------------------------------------
void _OS_DeletePTimer (OST_PTIMER *ptimer)
{

    asm volatile("   mov     #__OS_PTimers, w1       ");
    asm volatile("0:                                 "); // _OS_DELETE_PTIMER_NEXT
    asm volatile("   mov     w1, w5                  ");
    asm volatile("   mov     [w5], w2                ");
    asm volatile("   btss    w2, #3                  "); // bNextEnable
    asm volatile("   bra     1f                      "); // _OS_DELETE_PTIMER_EXIT
    asm volatile("   mov     [w5 + #2], w1           ");
    asm volatile("   cpseq   w0, w1                  ");
    asm volatile("   bra     0b                      "); // _OS_DELETE_PTIMER_NEXT
    asm volatile("   mov.d   [w0], w2                "); // w2 = flags, w3 = next
    asm volatile("   mov     w3, [w5 + #2]           "); // w1.next = w0.next
    asm volatile("   mov     [w5], w3                "); // flags
    asm volatile("   btss    w2, #3                  "); // skip if bNextEnable
    asm volatile("   bclr    w3, #3                  "); // clear bNextEnable
    asm volatile("   mov     w3, [w5]                ");
    asm volatile("   bclr    w2, #1                  "); // clear bActive
    asm volatile("   mov     w2, [w0]                "); // save flags
    asm volatile("1:                                 "); // _OS_DELETE_PTIMER_EXIT
}



#endif  //  OS_ENABLE_PTIMERS
















/****************************************************************************************************
 * 
 *                                /               
 *                  
 *
 * (  )
 *
 ****************************************************************************************************/


//------------------------------------------------------------------------------
#define _OS_CheckEvent_DEFINED
//------------------------------------------------------------------------------
void _OS_CheckEvent (_OST_INT_TYPE bEvent)
{
    asm volatile("  bclr    _OS_Flags, #8               "); // bTimeout
    asm volatile("  cp0     w0                          "); //  if (bEvent)
    asm volatile("  bra     Z, 0f                       "); // _OS_CHECK_EVENT_notEVENT
    asm volatile("  btss    _OS_state, #3               "); // Check ready
    asm volatile("  bra     1f                          "); // _OS_CHECK_EVENT_SetReady
    asm volatile("  bclr    _OS_state, #4               "); // Clear Delay
    asm volatile("  bra     2f                          "); // _OS_CHECK_EVENT_EXIT_GOOD
    asm volatile("1:                                    "); // _OS_CHECK_EVENT_SetReady
    asm volatile("  bset    _OS_state, #3               "); // Ready = 1
    asm volatile("  bra     3f                          "); // _OS_CHECK_EVENT_CHECK_END
    asm volatile("0:                                    "); // _OS_CHECK_EVENT_notEVENT
    asm volatile("  bclr    _OS_state, #3               "); // Ready = 1
    asm volatile("3:                                    "); // _OS_CHECK_EVENT_CHECK_END
    #ifdef OS_ENABLE_TIMER
        asm volatile("  btss    _OS_state, #4           "); //   
        asm volatile("  btss    _OS_state, #5           "); //   
        asm volatile("  bra     4f                      "); // _OS_CHECK_EVENT_EXIT_BAD
        asm volatile("  bset    _OS_Flags, #8           "); // bTimeout
        asm volatile("  bra     2f                      "); // _OS_CHECK_EVENT_EXIT_GOOD
    #endif
    asm volatile("4:                                    "); // _OS_CHECK_EVENT_EXIT_BAD
    asm volatile("  mov     #(1<<14), w0                "); //  bOSCheckEvent_LNK
    asm volatile("  goto    OS_RETURN                   ");

    asm volatile("2:                                    "); // _OS_CHECK_EVENT_EXIT_GOOD

}





