NEAR OST_TASK_STATE     OS_state    __osa30_near;

#define OS_Init_ProcSpec()      //  PICC12 -  




//------------------------------------------------------------------------------
#ifdef OS_ENABLE_TIMER

/****************************************************************************************************
 * 
 *                                  
 *
 ****************************************************************************************************/
/************************************************************************/
/*                                                                      */
/*                                    */
/* (  )                                         */
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_InitDelay_DEFINED
//------------------------------------------------------------------------------
void _OS_InitDelay (OST_TIMER Delay)
{

    _OS_bTaskCanContinue = 0;
    _OS_bTaskDelay = 0;

    if (Delay)
    {

        Delay ^= -1;
        Delay ++;
        
        #if     OS_TIMER_SIZE == 1
            asm("   movlw   2   ");
            asm("   addwf   __OS_CurTask, w ");
            _OS_PIC12_AND_1F();
            asm("   movwf   __fsr    ");
            asm("   movf    ?a__OS_InitDelay, w");
            _OS_SET_TASK_IRP();
            asm("   movwf   __indf");
            _OS_SET_TASK_IRP_0();
        #elif   OS_TIMER_SIZE == 2
            asm("   movlw   2   ");
            asm("   addwf   __OS_CurTask, w ");
            _OS_PIC12_AND_1F();
            asm("   movwf   __fsr    ");
            asm("   movf    ?__OS_InitDelay + 1, w");
            _OS_SET_TASK_IRP();
            asm("   movwf   __indf");
            
            _OS_SET_TASK_IRP_0();
            asm("   incf    __fsr ");
            asm("   movf    ?__OS_InitDelay + 2, w");
            _OS_SET_TASK_IRP();
            asm("   movwf   __indf");
            
            _OS_SET_TASK_IRP_0();

        #elif   OS_TIMER_SIZE == 4
            asm("   movlw   2   ");
            asm("   addwf   __OS_CurTask, w ");
            _OS_PIC12_AND_1F();
            asm("   movwf   __fsr    ");
            asm("   movf    ?__OS_InitDelay + 1, w");
            _OS_SET_TASK_IRP();
            asm("   movwf   __indf");
            
            _OS_SET_TASK_IRP_0();
            asm("   incf    __fsr ");
            asm("   movf    ?__OS_InitDelay + 2, w");
            _OS_SET_TASK_IRP();
            asm("   movwf   __indf");
            
            _OS_SET_TASK_IRP_0();
            asm("   incf    __fsr ");
            asm("   movf    ?__OS_InitDelay + 3, w");
            _OS_SET_TASK_IRP();
            asm("   movwf   __indf");
            
            _OS_SET_TASK_IRP_0();
            asm("   incf    __fsr ");
            asm("   movf    ?__OS_InitDelay + 4, w");
            _OS_SET_TASK_IRP();
            asm("   movwf   __indf");
            
            _OS_SET_TASK_IRP_0();
        #endif
        
        _OS_SET_FSR_CUR_TASK();
        _OS_bTaskDelay = 1;
        _OS_bTaskReady = 1;

    }
}

//______________________________________________________________________________
//******************************************************************************

#endif  // #ifdef OS_TIMER














/****************************************************************************************************
 * 
 * 
 *                                      
 *  
 *
 ****************************************************************************************************/
    
/************************************************************************/
/*                                                                      */
/*                     */
/*                                   */
/*                                                                      */
/************************************************************************/

//------------------------------------------------------------------------------
#define _OS_StopTask_DEFINED
//------------------------------------------------------------------------------

void _OS_StopTask (void)
{
    *((OS_TASKS_BANK _OST_INT_TYPE*)&_OS_CurTask->State) = 0;
    _fsr = 0;
}




/************************************************************************/
/*                                                                      */
/*     .                              */
/*  :                                                           */
/*      FSR -                                      */
/*      CARRY - =1 - ,                                                */
/*              =0 -    (  OS_TASKS)    */
/*                                                                      */
/************************************************************************/

//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
#define _OS_CreateTask_DEFINED
//------------------------------------------------------------------------------
bit _OS_CreateTask(_OST_INT_TYPE priority, OST_CODE_POINTER TaskAddr)
{
    OST_TASK_POINTER Task;
    
    OS_Flags.bError = 0;


    Task = (OST_TASK_POINTER)OS_TaskVars;
    _OS_temp = OS_TASKS;
    do {
        if (!Task->State.bEnable)
        {
            ((OST_TASK_STATE*)&priority)->bEnable = 1;
            ((OST_TASK_STATE*)&priority)->bReady = 1;
            
            asm("   incf    __OS_CreateTask$Task, w     ");
            _OS_PIC12_AND_1F();
            asm("   movwf   __fsr                        ");
            asm("   movf    __OS_CreateTask$TaskAddr, w      ");
            _OS_SET_TASK_IRP();
            asm("   movwf    __indf ");
            asm("   decf    __fsr   ");
            _OS_SET_TASK_IRP_0();
            asm("   movf    __OS_CreateTask$priority, w      ");   // priority
            _OS_SET_TASK_IRP();
            asm("   movwf    __indf ");
            _OS_SET_TASK_IRP_0();
            if (Task == _OS_CurTask) OS_state = *((OST_TASK_STATE*)&priority);
            OS_Flags.bError = 0;
            return 1;
        
        }
        Task ++;
    } while (_OS_temp--);
    //  ,     
    OS_Flags.bError = 1;
    return 0;
}














 /******************************************************************************************
 *
 *             P T I M E R '    
 *
 ******************************************************************************************/
#ifdef OS_ENABLE_PTIMERS

/************************************************************************/
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_CreatePTimer_DEFINED
//------------------------------------------------------------------------------
void _OS_CreatePTimer (OST_PTIMER *ptimer)
{
    //------------------------------------------------------------------------------
    // ptimer->Flags = _OS_PTimers.Flags;
        #if _BANKBITS_ == 2
        asm("   bcf     __status, 0             ");
        asm("   btfsc   __OS_CreatePTimer$ptimer, 6  ");
        asm("   bsf     __status, 0             ");
        #endif
        asm("   movf    __OS_CreatePTimer$ptimer, w  ");
        _OS_PIC12_AND_1F();
        asm("   movwf   __fsr                   ");
        //-------
        _OS_SET_OS_IRP();
        asm("   movf    __OS_PTimers & 0x1F, w  ");
        _OS_SET_OS_IRP_0();
        //-------
        #if _BANKBITS_ >= 1
        asm("   btfsc   __OS_CreatePTimer$ptimer, 5 ");
        asm("   bsf     __fsr, 5            ");
        #endif
        #if _BANKBITS_ == 2
        asm("   btfsc   __status, 0 ");
        asm("   bsf     __fsr, 6            ");
        #endif
        asm("   movwf   __indf              ");
        _fsr = 0;

    //------------------------------------------------------------------------------
    // ptimer->Next = _OS_PTimers.Next;
        
        /*    CARRY = a__OS_CreatePTimer.6 */

        asm("   movf    __OS_CreatePTimer$ptimer, w      ");
        _OS_PIC12_AND_1F();
        asm("   movwf   __fsr                       ");
        asm("   incf    __fsr, f                    ");
        //-------
        _OS_SET_OS_IRP();
        asm("   movf    (__OS_PTimers + 1) & 0x1F, w");
        _OS_SET_OS_IRP_0();
        //-------
    #if _BANKBITS_ >= 1
        asm("   btfsc   __OS_CreatePTimer$ptimer, 5      ");
        asm("   bsf     __fsr, 5                    ");
    #endif
    #if _BANKBITS_ == 2
        asm("   btfsc   __status, 0 ");
        asm("   bsf     __fsr, 6                    ");
    #endif
        asm("   movwf   __indf                      ");
        _fsr = 0;
        
    //------------------------------------------------------------------------------
    ptimer->Timer = 0;

            
    _OS_PTimers.Next = (OST_PTIMER*)ptimer;
    _OS_PTimers.Flags.bNextEnable = 1;
    
}






/************************************************************************/
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_DeletePTimer_DEFINED
//------------------------------------------------------------------------------
void _OS_DeletePTimer (OST_PTIMER *ptimer)
{

    OST_PTIMER *ptcb;
    
    ptcb = (OST_PTIMER*)&_OS_PTimers;
    while (ptcb->Flags.bNextEnable) {
        if (ptcb->Next == ptimer) {   //  
            _OS_temp = (_OST_INT_TYPE)ptimer->Next;
            //------------------------------------------------------------------------------
            //ptcb->Next = _OS_temp;
            #if _BANKBITS_ == 2
                asm("   bcf     __status, 0                 ");
                asm("   btfsc   __OS_DeletePTimer$ptcb, 6   ");
                asm("   bsf     __status, 0                 ");
            #endif
            asm("   movf    __OS_DeletePTimer$ptcb, w       ");
            _OS_PIC12_AND_1F();
            asm("   movwf   __fsr                   ");
            asm("   incf    __fsr, f                ");
            //-------
            asm("   movf    __OS_temp, w  ");
            //-------
            #if _BANKBITS_ >= 1
                asm("   btfsc   __OS_DeletePTimer$ptcb, 5   ");
                asm("   bsf     __fsr, 5                    ");
            #endif
            #if _BANKBITS_ == 2
                asm("   btfsc   __status, 0 ");
                asm("   bsf     __fsr, 6            ");
            #endif
            asm("   movwf   __indf              ");
            _fsr = 0;
            
            if (!ptimer->Flags.bNextEnable) ptcb->Flags.bNextEnable = 0;
            ptimer->Flags.bActive = 0;
            return;
        }
        ptcb = ptcb->Next;
    }
}



#endif  //  OS_ENABLE_PTIMERS


























/****************************************************************************************************
 * 
 *                                /               
 *                  
 *
 * (  )
 *
 ****************************************************************************************************/


//------------------------------------------------------------------------------
#define _OS_CheckEvent_DEFINED
//------------------------------------------------------------------------------
bit _OS_CheckEvent (char bEvent)
{
    OS_Flags.bTimeout = 0;
    if (bEvent) {
        if (_OS_bTaskReady) {
            #ifdef OS_ENABLE_TIMER
                _OS_bTaskDelay = 0;
            #endif
            return 1;
        }
        _OS_bTaskReady = 1;
    } else _OS_bTaskReady = 0;
    #ifdef OS_ENABLE_TIMER
        if (_OS_bTaskTimeout && _OS_bTaskCanContinue) {
            OS_Flags.bTimeout = 1;
            return 1;
        }
    #endif
    return 0;
}


    

        

        











/****************************************************************************************************
 * 
 * 
 *                                                    
 *  
 *
 ****************************************************************************************************/


//------------------------------------------------------------------------------
#if defined(OS_ENABLE_QMSG)

/************************************************************************/
/*                                                                      */
/*                                   */
/*  1,                        */
/*                                                                      */
/************************************************************************/

//------------------------------------------------------------------------------
#define _OS_SendQMsg_DEFINED
#define _OS_SendQSMsg_DEFINED
//------------------------------------------------------------------------------

void _OS_SendQMsg (OST_QMSG *pQMsg, OST_MSG Msg)
{
    OS_Flags.bEventError = 0;

    // if pQMsg->Q.cSize == pQMsg->Q.cFilled
    _fsr = (_FSR_TYPE) pQMsg;
    asm("   movf    __indf, w               ");     // w = pQMsg->Q.cSize
    asm("   incf    __fsr, f                ");     // fsr -> pQMsg->Q.cFilled
    asm("   xorwf   __indf, w               ");     //  cSize  cFilled
    
    if (_status & 0x04) {   //  ZERO

        _fsr = 0;
        OS_Flags.bEventError = 1;

        // pQMsg->pMsg[pQMsg->Q.cBegin] = Msg;
        _fsr = (_FSR_TYPE) pQMsg;
        asm("   incf    __fsr, f        ");
        asm("   incf    __fsr, f        ");
        asm("   movf    __indf, w       ");     // w = pQMsg->Q.cBegin
    PUT_MESSAGE:
        asm("   incf    __fsr, f        ");
        asm("   addwf   __indf, w       ");
        asm("   movwf   __fsr           ");     // fsr -> pQMsg->pMsg[pQMsg->Q.cBegin]
        


        #ifdef _16F59
            asm("   bcf     __status, 5     "); //    ROM   FSR.7
            asm("   btfsc   __fsr, 7        ");
            asm("   bsf     __status, 5     ");
            asm("   bcf     __fsr, 7     ");
        #endif

        #if _BANKBITS_ == 2
            asm("   bcf     __status, 1     ");
            asm("   btfsc   __fsr, 6        ");
            asm("   bsf     __status, 1     ");
            asm("   bcf     __fsr, 6     ");
        #endif
        #if _BANKBITS_ >= 1
            asm("   bcf     __status, 0     ");
            asm("   btfsc   __fsr, 5        ");
            asm("   bsf     __status, 0     ");
            asm("   bcf     __fsr, 5     ");
        #endif

        asm("   movf    __OS_SendQMsg$Msg, w    ");

        #ifdef _16F59
            asm("   btfsc   __status, 5     "); //    ROM   FSR.7
            asm("   bsf     __fsr, 7        ");
            asm("   dw  0x4A3   | (($ & 0x200) >>1)");
        #endif
        #if _BANKBITS_ == 2
            asm("   btfsc   __status, 1     ");
            asm("   bsf     __fsr, 6        ");
        #endif
        #if _BANKBITS_ >= 1
            asm("   btfsc   __status, 0     ");
            asm("   bsf     __fsr, 5        ");
        #endif
        asm("   movwf   __indf              ");

        
        //  status, c = bEventError.
        //           cSize:
        //   ,   cBegin,  cFilled
        
        _fsr = 0;
        _status &= 0xFE;
        if (OS_Flags.bEventError) _status |= 0x01;

        // pQMsg->Q.cBegin++ ( pQMsg->Q.cFileld++)     cSize
        _fsr = (_FSR_TYPE) pQMsg;
        asm("   movf    __indf, w               ");
        asm("   btfsc   __status, 0             ");     //   fsr,    
        asm("   incf    __fsr, f                ");
        asm("   incf    __fsr, f                ");     // fsr -> pQMsg->Q.cBegin
        asm("   incf    __indf, f               ");     // cBegin++ ( cFilled++)
        if (_status & 1) {        
            asm("   xorwf   __indf, w           ");     //  cBegin ( cFilled)  cSize
            asm("   btfsc   __status, 2         ");
            asm("   clrf    __indf              ");     // cBegin ( cFilled) = 0
        }    
        asm("   clrf    __fsr                   ");
        return;
    }

    //temp = q.cBegin + q.cFilled;
    //if (temp >= q.cSize) temp -= q.cSize;
    asm("   incf    __fsr, f                ");
    asm("   movf    __indf, w               ");     // w = cBegin
    asm("   decf    __fsr, f                ");
    asm("   addwf   __indf, w               ");     // w += cFilled
    asm("   decf    __fsr, f                ");
    asm("   subwf   __indf, w               ");     // w = cSize - (cFileld + cBegin)
    asm("   btfss   __status, 0             ");     // > 0
    asm("   addwf   __indf, w               ");     // 
    asm("   subwf   __indf, w               ");     // w = cSize - (cFileld + cBegin)
    asm("   incf    __fsr, f                ");
    asm("   incf    __fsr, f                ");
    goto    PUT_MESSAGE;

}



/************************************************************************/
/*                                                                      */
/*                                         */
/*                                                                      */
/************************************************************************/

//------------------------------------------------------------------------------
#define _OS_GetQMsg_DEFINED
#define _OS_GetQSMsg_DEFINED
//------------------------------------------------------------------------------

OST_MSG _OS_GetQMsg (OST_QMSG *pQMsg)
{
    char temp;

    _fsr = (_FSR_TYPE)pQMsg;
    _fsr++;
    _fsr++;
    asm("   movf    __indf, w           "); // w = cBegin
    asm("   incf    __fsr, f            "); // fsr -> pMsg
    asm("   addwf   __indf, w           "); 
    asm("   movwf   __fsr               "); // fsr -> pMsg[cBegin]
    asm("   movf    __indf, w           "); // w = pMsg[cBegin]
    asm("   clrf    __fsr               ");
    asm("   movwf   __OS_GetQMsg$temp   ");

    //   5  6   -   temp
    _fsr = (_FSR_TYPE)pQMsg;
    asm("   movf    __indf, w           ");
    asm("   incf    __fsr, f            ");
    asm("   incf    __fsr, f            ");
    asm("   incf    __indf, f           "); // cBegin++
    asm("   subwf   __indf, w           ");
    asm("   btfsc   __status, 0         "); // if (cBegin >= cSize) cBegin = 0;
    asm("   clrf    __indf              ");
    asm("   decf    __fsr, f            ");
    asm("   decf    __indf, f           "); // cFilled--

    _fsr = 0;
    return (OST_MSG)temp;
}
#endif
//------------------------------------------------------------------------------


















