

#define OS_Init_ProcSpec()      //  PICC16 -  






/**************************************************************************************************
 * 
 *            F S R       O S _ C U R _ T A S K
 *
 *   
 *
 **************************************************************************************************/

#if defined(_ROMSIZE) && (_ROMSIZE <= 0x800)

    asm("   global __OS_SET_FSR_CUR_TASK        ");
    asm("   global __OS_SET_FSR_CUR_TASK_W      ");
    asm("__OS_SET_FSR_CUR_TASK:                 ");
    asm("       movlw       0                   ");
    asm("__OS_SET_FSR_CUR_TASK_W:               ");
    asm("       addwf       __OS_CurTask, w     ");
    asm("       movwf       __fsr               ");
    #if OS_BANK_TASKS >= 2
    asm("       bsf         __status, 7         ");
    #else
    asm("       bcf         __status, 7         ");
    #endif
    asm("       return                          ");

#endif




















/**************************************************************************************************
 * 
 * C O U N T I N G    S E M A P H O R E S
 *
 * (OS_ENABLE_CSEM must be defined in OSAcfg.h)
 *
 **************************************************************************************************/


#ifdef OS_ENABLE_CSEM



/************************************************************************/
/*     1                                    */
/************************************************************************/

//------------------------------------------------------------------------------
#define _OS_SignalCSem_DEFINED
//------------------------------------------------------------------------------
    
void _OS_SignalCSem (OST_CSEM *pCSem)
{
    #ifdef OS_ENABLE_INT_SERVICE
        _OST_INT_TYPE cGIETemp;
        cGIETemp = OS_DI();
    #endif

    OS_Flags.bEventError = 0;               //   ,    

    //------------------------------------------------------------------------------
    //    
    #if OS_CSEM_SIZE == 1
        _fsr = (_FSR_TYPE)pCSem;
        #ifdef __OSAPICC__
            _status &= 0x7F;        //  IRP
        #endif
        _indf++;
        if (!_indf)
        {
            _indf--;
            OS_Flags.bEventError = 1;
        }

    //------------------------------------------------------------------------------
    //    
    #elif OS_CSEM_SIZE == 2
        _fsr = (_FSR_TYPE)pCSem;
        _status &= 0x7F;        //  IRP
        asm("\t    movlw    1     ");
        asm("\t    addwf    __indf,f    ");
        asm("\t    incf     __fsr, f    ");
        asm("\t    btfsc    __status, 0     ");
        asm("\t    incf     __indf,f     ");
        asm("\t    movf     __indf, w     ");
        asm("\t    decf     __fsr, f     ");
        asm("\t    iorwf    __indf, w      ");
        if (ZERO) {
            asm("\t    movlw    -1     ");
            asm("\t    movwf    __indf     ");
            asm("\t    incf     __fsr,f     ");
            asm("\t    movwf    __indf     ");
            OS_Flags.bEventError = 1;
        }
    //------------------------------------------------------------------------------
    //    
    #else 
        (*pCSem)++;
        if (!*pCSem) {          //   ,    
            (*pCSem) = -1;
            OS_Flags.bEventError = 1;
        }
    #endif
    //------------------------------------------------------------------------------
    
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
}

#endif











/****************************************************************************************************
 * 
 *       GIE
 * 
 * char OS_DI (void)   
 *
 ****************************************************************************************************/

#define OS_DI_DEFINED

asm("   global _OS_DI           ");
asm("_OS_DI:                    ");
asm("   clrf    __status        ");
asm("   movf    __intcon, w      ");
asm("   andlw   0x80            ");
asm("_DI_REPEAT:                ");
asm("   bcf     __intcon, 7      ");
asm("   btfss   __intcon, 7      ");
asm("   return                  ");
asm("   goto    _DI_REPEAT      ");









 
    
    
/****************************************************************************************************
 * 
 *        
 * 
 *
 ****************************************************************************************************/
//------------------------------------------------------------------------------
#ifdef OS_ENABLE_CRITICAL_SECTION
//------------------------------------------------------------------------------
    
/************************************************************************/
/*                                                */
/************************************************************************/
#define OS_EnterCriticalSection_DEFINED

void OS_EnterCriticalSection (void)
{
    _OST_INT_TYPE temp;
    temp = OS_DI();
    OS_Flags.bInCriticalSection = 1; 

    OS_Flags.bGIE_CTemp = 0;
    if (temp & 0x80) OS_Flags.bGIE_CTemp = 1;

}

/************************************************************************/
/*                                              */
/************************************************************************/
#define OS_LeaveCriticalSection_DEFINED

void OS_LeaveCriticalSection (void)
{
    char temp;
    OS_Flags.bInCriticalSection = 0; 
    temp = 0;
    if (OS_Flags.bGIE_CTemp) temp |= 0x80;
    OS_RI(temp);
}

//------------------------------------------------------------------------------
#endif      //     #ifdef OS_ENABLE_CRITICAL_SECTION
//------------------------------------------------------------------------------


















//------------------------------------------------------------------------------
#ifdef OS_ENABLE_TIMER

/****************************************************************************************************
 * 
 *                                  
 *
 ****************************************************************************************************/
/************************************************************************/
/*                                                                      */
/*                                    */
/* (  )                                         */
/*                                                                      */
/************************************************************************/
#define _OS_InitDelay_DEFINED


void _OS_InitDelay (OST_TIMER Delay)
{

    _OS_SET_FSR_CUR_TASK();
    _OS_bTaskCanContinue = 0;
    _OS_bTaskDelay = 0;

    if (Delay)
    {

        Delay ^= -1;
        Delay ++;
        _OS_CurTask->Timer = Delay;
        
        _OS_SET_FSR_CUR_TASK();
        _OS_bTaskDelay = 1;
        _OS_bTaskReady = 1;

    }
}

//______________________________________________________________________________
//******************************************************************************

#endif  // #ifdef OS_TIMER



    










    
    
    
    
    

    







/****************************************************************************************************
 * 
 * 
 *                                      
 *  
 *
 ****************************************************************************************************/
    
/************************************************************************/
/*                                                                      */
/*                     */
/*                                   */
/*                                                                      */
/************************************************************************/
#define _OS_StopTask_DEFINED

 
void _OS_StopTask (void)
{
    _OS_SET_FSR_CUR_TASK();
    _indf = 0;
}




/************************************************************************/
/*                                                                      */
/*     .                              */
/*  :                                                           */
/*      FSR -                                      */
/*      CARRY - =1 - ,                                                */
/*              =0 -    (  OS_TASKS)    */
/*                                                                      */
/************************************************************************/

//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
#define _OS_CreateTask_DEFINED

bit _OS_CreateTask(_OST_INT_TYPE priority, OST_CODE_POINTER TaskAddr)
{
    OST_TASK_POINTER Task;
    
    OS_Flags.bError = 0;

    #if defined(OS_DISABLE_PRIORITY)
    priority = 0;   //    
    #endif

    Task = (OST_TASK_POINTER)OS_TaskVars;
    _OS_temp = OS_TASKS;
    do {
        if (!Task->State.bEnable)
        {
            ((OST_TASK_STATE*)&priority)->bEnable = 1;
            ((OST_TASK_STATE*)&priority)->bReady = 1;
            

            Task->pTaskPointer = TaskAddr;
            #ifdef OS_ENABLE_TIMER
                Task->Timer = 0;
            #endif
            *((OS_TASKS_BANK char*)&Task->State) = priority;
            //    FSR =    
            OS_Flags.bError = 0;
            return 1;
        
        }
        Task ++;
    } while (_OS_temp--);
    //  ,     
    OS_Flags.bError = 1;
    return 0;
}

































 /******************************************************************************************
 *
 *             P T I M E R '    
 *
 ******************************************************************************************/
#ifdef OS_ENABLE_PTIMERS

/************************************************************************/
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_CreatePTimer_DEFINED
//------------------------------------------------------------------------------

void _OS_CreatePTimer (OST_PTIMER *ptimer)
{
    _OS_temp = OS_DI();
    
    _fsr = (_FSR_TYPE) ptimer;
    _indf = *((OS_BANK char*)&_OS_PTimers.Flags); //  bActive,
                                          //  bTimeout,
                                          //  bRun
                                          //  bNextEnable;
    _fsr++;
    _indf = (_FSR_TYPE)_OS_PTimers.Next;

    _fsr++;
    _indf = 0;
    _fsr++;
    #if  OS_TIMER_SIZE >= 2
        _indf = 0;
        _fsr++;
    #endif
    #if  OS_TIMER_SIZE == 4
        _indf = 0;
        _fsr++;
        _indf = 0;
    #endif


    _OS_PTimers.Next = (OST_PTIMER*)ptimer;
    _OS_PTimers.Flags.bNextEnable = 1;
    
    #if !defined(__OSAPICC12__)
    OS_RI(_OS_temp);
    #endif
}





/************************************************************************/
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_DeletePTimer_DEFINED
//------------------------------------------------------------------------------
void _OS_DeletePTimer (OST_PTIMER *ptimer)
{

    OST_PTIMER *ptcb;
    
    char flags;
    _fsr = ((_FSR_TYPE)ptimer);
    flags = _indf;
    _OS_ClearIndfTimerActive;           //   
    _fsr++;
    ptcb = (_FSR_TYPE)_indf;
    _fsr = (_FSR_TYPE)&_OS_PTimers;
    //     
REPEAT:
    if (_OS_CheckIndfTimerNextEnable)   // ,   
    {
        _fsr++;
        if ((_FSR_TYPE)_indf == (_FSR_TYPE)ptimer)  // ,    
        {
            _OS_temp = OS_DI();         //  
            _indf = *((char*)&ptcb);    //  
            _fsr--;                     
            //  ,      
            if (!((OST_PTIMER_FLAGS*)&flags)->bNextEnable) _OS_ClearIndfTimerNextEnable;
            OS_RI(_OS_temp);
            return;
        }
        _fsr = (_FSR_TYPE)_indf;
        goto REPEAT;
    }
        
}



#endif  //  OS_ENABLE_PTIMERS


























/****************************************************************************************************
 * 
 *                                /               
 *                  
 *
 * (  )
 *
 ****************************************************************************************************/


//------------------------------------------------------------------------------
#define _OS_CheckEvent_DEFINED
//------------------------------------------------------------------------------
bit _OS_CheckEvent (char bEvent)
{



    OS_Flags.bTimeout = 0;
    _OS_SET_FSR_CUR_TASK();
    CARRY = 0;
    if (bEvent) {
        if (_OS_bTaskReady) {
    EXIT_OK:
            CARRY = 1;
        }
        _OS_bTaskReady = 1;
        #if defined(OS_ENABLE_TIMER)
            if (CARRY) _OS_bTaskDelay = 0;
        #endif
        asm("   return     ");
    }
    _OS_bTaskReady = 0;
    #if defined(OS_ENABLE_TIMER)
        asm("   btfss   __indf, 4     ");
        asm("   btfss   __indf, 5     ");
        asm("   return                ");
        OS_Flags.bTimeout = 1;
        goto EXIT_OK;
    #else
        asm("   return  ");
    #endif

}


