


//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     T I M E R S                                                                              */
/*                                                                                                              */
/****************************************************************************************************************/

//------------------------------------------------------------------------------
//   
#define OS_StopTimer(timer_id)      { OS_Timeouts[(timer_id) >> _OST_INT_SHIFT] &= ~(1 << ((timer_id) & _OST_INT_MASK)); }

//------------------------------------------------------------------------------
//   ( )
#define _OS_RunTimer(timer_id)      { OS_Timeouts[(timer_id) >> _OST_INT_SHIFT] |=  (1 << ((timer_id) & _OST_INT_MASK)); }

//------------------------------------------------------------------------------
// ,    
#define OS_CheckTimer(timer_id)     (!(OS_Timeouts[(timer_id) >> _OST_INT_SHIFT] & (1 << ((timer_id) & _OST_INT_MASK))))

//------------------------------------------------------------------------------
// ,   
#define OS_IsTimerRun(timer_id)     (OS_Timeouts[(timer_id) >> _OST_INT_SHIFT] & (1 << ((timer_id) & _OST_INT_MASK)))


//------------------------------------------------------------------------------
//   8   
#define OS_RunTimer8(timer_id, time)                                \
    {                                                               \
        OS_StopTimer(timer_id);                                     \
        OS_Timers8 [timer_id] = -(time);                            \
        _OS_RunTimer(timer_id);                                     \
    }


//------------------------------------------------------------------------------
//   16   
#define OS_RunTimer16(timer_id, time)                               \
    {                                                               \
        OS_StopTimer(timer_id);                                     \
        OS_Timers16[(timer_id) - _OS_TIMER16_POS] = -(time);          \
        _OS_RunTimer(timer_id);                                     \
    }

//------------------------------------------------------------------------------
//   24   (time -   )
#define OS_RunTimer24(timer_id, time)                                   \
    {                                                                   \
        OS_StopTimer(timer_id);                                         \
        OS_Timers24[(timer_id) - _OS_TIMER24_POS] = - (((time) + 128) >> 8); \
        _OS_RunTimer(timer_id);                                         \
    }
    
//------------------------------------------------------------------------------
//   24     
//    , ..     
//     ,     8.
#define OS_RunTimer24prs(timer_id, time)                            \
    {                                                               \
        OS_StopTimer(timer_id);                                     \
        OS_Timers24[(timer_id) - _OS_TIMER24_POS] = -(time);        \
        _OS_RunTimer(timer_id);                                     \
    }

//------------------------------------------------------------------------------
//   32   
#define OS_RunTimer32(timer_id, time)                               \
    {                                                               \
        OS_StopTimer(timer_id);                                     \
        OS_Timers32[(timer_id) - _OS_TIMER32_POS] = -(time);        \
        _OS_RunTimer(timer_id);                                     \
    }
//------------------------------------------------------------------------------
//     
#define OS_WaitTimer(timer_id)                                              \
    {                                                                       \
        _OS_WAIT_EVENT(OS_CheckTimer(timer_id));                            \
    }
      
//------------------------------------------------------------------------------
//        
#define OS_DelayTimer8(timer_id, delay)     \
    {                                       \
        OS_RunTimer8(timer_id, delay);      \
        OS_WaitTimer(timer_id);             \
    }

//------------------------------------------------------------------------------
#define OS_DelayTimer16(timer_id, delay)    \
    {                                       \
        OS_RunTimer16(timer_id, delay);     \
        OS_WaitTimer(timer_id);             \
    }

//------------------------------------------------------------------------------
#define OS_DelayTimer24(timer_id, delay)    \
    {                                       \
        OS_RunTimer24(timer_id, delay);     \
        OS_WaitTimer(timer_id);             \
    }

//------------------------------------------------------------------------------
#define OS_DelayTimer32(timer_id, delay)    \
    {                                       \
        OS_RunTimer32(timer_id, delay);     \
        OS_WaitTimer(timer_id);             \
    }



